/*
Copyright 2020 The SuperEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	superedgeiov1 "github.com/superedge/superedge/pkg/application-grid-controller/apis/superedge.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDeploymentGrids implements DeploymentGridInterface
type FakeDeploymentGrids struct {
	Fake *FakeSuperedgeV1
	ns   string
}

var deploymentgridsResource = schema.GroupVersionResource{Group: "superedge.io", Version: "v1", Resource: "deploymentgrids"}

var deploymentgridsKind = schema.GroupVersionKind{Group: "superedge.io", Version: "v1", Kind: "DeploymentGrid"}

// Get takes name of the deploymentGrid, and returns the corresponding deploymentGrid object, and an error if there is any.
func (c *FakeDeploymentGrids) Get(ctx context.Context, name string, options v1.GetOptions) (result *superedgeiov1.DeploymentGrid, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(deploymentgridsResource, c.ns, name), &superedgeiov1.DeploymentGrid{})

	if obj == nil {
		return nil, err
	}
	return obj.(*superedgeiov1.DeploymentGrid), err
}

// List takes label and field selectors, and returns the list of DeploymentGrids that match those selectors.
func (c *FakeDeploymentGrids) List(ctx context.Context, opts v1.ListOptions) (result *superedgeiov1.DeploymentGridList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(deploymentgridsResource, deploymentgridsKind, c.ns, opts), &superedgeiov1.DeploymentGridList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &superedgeiov1.DeploymentGridList{ListMeta: obj.(*superedgeiov1.DeploymentGridList).ListMeta}
	for _, item := range obj.(*superedgeiov1.DeploymentGridList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested deploymentGrids.
func (c *FakeDeploymentGrids) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(deploymentgridsResource, c.ns, opts))

}

// Create takes the representation of a deploymentGrid and creates it.  Returns the server's representation of the deploymentGrid, and an error, if there is any.
func (c *FakeDeploymentGrids) Create(ctx context.Context, deploymentGrid *superedgeiov1.DeploymentGrid, opts v1.CreateOptions) (result *superedgeiov1.DeploymentGrid, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(deploymentgridsResource, c.ns, deploymentGrid), &superedgeiov1.DeploymentGrid{})

	if obj == nil {
		return nil, err
	}
	return obj.(*superedgeiov1.DeploymentGrid), err
}

// Update takes the representation of a deploymentGrid and updates it. Returns the server's representation of the deploymentGrid, and an error, if there is any.
func (c *FakeDeploymentGrids) Update(ctx context.Context, deploymentGrid *superedgeiov1.DeploymentGrid, opts v1.UpdateOptions) (result *superedgeiov1.DeploymentGrid, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(deploymentgridsResource, c.ns, deploymentGrid), &superedgeiov1.DeploymentGrid{})

	if obj == nil {
		return nil, err
	}
	return obj.(*superedgeiov1.DeploymentGrid), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDeploymentGrids) UpdateStatus(ctx context.Context, deploymentGrid *superedgeiov1.DeploymentGrid, opts v1.UpdateOptions) (*superedgeiov1.DeploymentGrid, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(deploymentgridsResource, "status", c.ns, deploymentGrid), &superedgeiov1.DeploymentGrid{})

	if obj == nil {
		return nil, err
	}
	return obj.(*superedgeiov1.DeploymentGrid), err
}

// Delete takes name of the deploymentGrid and deletes it. Returns an error if one occurs.
func (c *FakeDeploymentGrids) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(deploymentgridsResource, c.ns, name), &superedgeiov1.DeploymentGrid{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDeploymentGrids) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(deploymentgridsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &superedgeiov1.DeploymentGridList{})
	return err
}

// Patch applies the patch and returns the patched deploymentGrid.
func (c *FakeDeploymentGrids) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *superedgeiov1.DeploymentGrid, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(deploymentgridsResource, c.ns, name, pt, data, subresources...), &superedgeiov1.DeploymentGrid{})

	if obj == nil {
		return nil, err
	}
	return obj.(*superedgeiov1.DeploymentGrid), err
}
